<?php
/**
 * IMPORTANT NOTE
 * The code of this system is closed and a private proprietary of Flex Solutions.
 * A written authorization/license from Flex Solutions is required before using or modifying this code.
 * Email: sales@flexsolution.biz, Phone: +962795342585, Website: http://www.flexsolutions.biz
 */
 

/**
 * This is the model class for table "person_pos".
 *
 * The followings are the available columns in table 'person_pos':
 * @property integer $id
 * @property integer $person_id
 * @property integer $pos_id
 * @property integer $created_by
 * @property string $created_date
 * @property integer $last_edited_by
 * @property string $last_edited_date
 *
 * The followings are the available model relations:
 * @property Person $person
 * @property Pos $pos
 */
class PersonPos extends LsmsActiveRecord
    {

    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return PersonPos the static model class
     */
    // the assigned Pos to specific Person
    public $assigned_POSs;

    public static function model( $className=__CLASS__ )
    {
        return parent::model($className);
    }

    /**
     * @return string the associated database table name
     */
    public function tableName()
    {
        return 'person_pos';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules()
    {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('person_id, pos_id', 'required'),
            array('person_id, pos_id', 'numerical', 'integerOnly' => true),
            array('pos_id', 'unique', 'criteria' => array(
                    'condition' => '`person_id`=:pos',
                    'params' => array(
                        ':pos' => $this->person_id
                    )
                )
                , 'message' => Yii::t('default', 'The same POS cannot be assigned twice')
            ),
            // The following rule is used by search().
            // Please remove those attributes that should not be searched.
            array('id, person_id, pos_id', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'person' => array(self::BELONGS_TO, 'Person', 'person_id'),
            'pos' => array(self::BELONGS_TO, 'Pos', 'pos_id'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels()
    {
        return array(
            'person_id' => yii::t("default", 'Person'),
            'pos_id' => yii::t("default", 'Pos'),
            'assigned_POSs' => yii::t('default', 'Assigned POSs'),
        );
    }

    public function attributeLabelsPopover()
    {
        return array();
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
     */
    public function search()
    {
        // Warning: Please modify the following code to remove attributes that
        // should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('person_id', $this->person_id);
        $criteria->compare('pos_id', $this->pos_id);

        $pageSize = $this->yiiparam('pageSize');
        return new CActiveDataProvider($this, array(
            'pagination' => array('pageSize' => $pageSize,),
            'criteria' => $criteria,
        ));
    }

    public static function getAll( $status=null )
    {
        if ($status == "Active")
        {
            return PersonPos::model()->active()->findAll(array('order' => 'pos_id'));
        }
        else
        {
            return PersonPos::model()->findAll(array('order' => 'pos_id'));
        }
    }

    }